#!/bin/bash
sed -i -e "s/redminekey/${REDMINE_KEY}/g" /usr/share/gitweb/post-receive
sed -i -e "s/redminekey/${REDMINE_KEY}/g" /settings.sql
sed -i -e "s/redminetokensession/${REDMINE_TOKEN_SESSION}/g" /settings.sql
sed -i -e "s/redminetokenapi/${REDMINE_TOKEN_API}/g" /settings.sql
if [ ! -z "$GITPROJECT" ]; then
    REPOS='/var/lib/git/'$GITPROJECT'.git'
    if [ ! -d $REPOS ]; then
        addrepos $GITPROJECT
        cd $REPOS
        chmod -R g+ws .
        chgrp -R nginx .
        cp /usr/share/gitweb/post-receive $REPOS/hooks/post-receive
    fi
    addauth $GITUSER $GITPASSWORD
    COUNT=0
    while [  $COUNT -lt 4 ]; do
        COUNT=0
        while [  $COUNT -lt 4 ]; do
            psql postgresql://postgres:postgres@pgredmine:5432 -f /settings.sql
            if [ $? -eq 0 ];then           
                curl -v -H "Content-Type: application/json" -X POST -H "X-Redmine-API-Key: $REDMINE_TOKEN_API" http://redmine:3000/projects.json -d '{"project": {"identifier": "'$GITPROJECT'", "name": "'$GITPROJECT'"}}'
                cp /getidproject.sql.ini /getidproject.sql
                sed -i -e "s/gitproject/${GITPROJECT}/g" /getidproject.sql
                cp /setrepositories.sql.ini /setrepositories.sql
                idproject=$(psql postgresql://postgres:postgres@pgredmine:5432 -f /getidproject.sql -S -t)
                sed -i -e "s/idproject/${idproject}/g" /setrepositories.sql
                sed -i -e "s/gitproject/${GITPROJECT}/g" /setrepositories.sql
                psql postgresql://postgres:postgres@pgredmine:5432 -f /setrepositories.sql
                rm /getidproject.sql
                rm /setrepositories.sql
                exit 0
            fi
            let COUNT=COUNT+1
            echo "retry after 30s"
            sleep 30
        done
    done
fi 